﻿using System;
using System.Collections.Generic;

using System.Data.Entity;
using System.Data.Entity.Infrastructure;

//QQ群：33353329
//blog：oppoic.cnblogs.com

namespace DbContexts.DataAccess
{
    public class BreakAwayContext : DbContext
    {
        public BreakAwayContext()
            : base("name=BreakAwayContext")
        {
            ((IObjectContextAdapter)this).ObjectContext
            .ObjectMaterialized += (sender, args) =>
            {
                var entity = args.Entity as DbContexts.Model.IObjectWithState;
                if (entity != null)
                {
                    entity.State = DbContexts.Model.State.Unchanged;
                }
            };
        }

        //以下是数据库上下文对象，以后对数据库的访问就用下面对象
        public DbSet<DbContexts.Model.Destination> Destinations { get; set; }
        public DbSet<DbContexts.Model.Lodging> Lodgings { get; set; }
        public DbSet<DbContexts.Model.Trip> Trip { get; set; }
        public DbSet<DbContexts.Model.Person> People { get; set; }
        public DbSet<DbContexts.Model.Reservation> Reservations { get; set; }
        public DbSet<DbContexts.Model.Payment> Payments { get; set; }
        public DbSet<DbContexts.Model.Activity> Activities { get; set; }


        //用Fluent api必须重写OnModelCreating方法
        protected override void OnModelCreating(DbModelBuilder modelBuilder)
        {
            //本例使用的Data Annotation配置的数据库，故这里一行也没有

        }
    }
}
